if lca==nil then lca={} end
lca.barrel={}
lca.barrel.expl={}

lca.barrel.sfx_attack=loadsfx("throw.ogg")
lca.barrel.sfx_bounce=loadsfx("bounce.wav")
lca.barrel.gfx_wpn=loadgfx("weapons/doom/barrel.png")
setmidhandle(lca.barrel.gfx_wpn)

lca.barrel.id=addweapon("lca.barrel","Barrel",lca.barrel.gfx_wpn,5,1)

function lca.barrel.draw()
	if weapon_shots==0 then
		hudpositioning(pos_build,lca.barrel.gfx_wpn,75,1,1,1)
	end
end

function lca.barrel.attack(attack)
	if (weapon_shots<=0) and (weapon_position==1) then
		useweapon(0)
		playsound(lca.barrel.sfx_attack)
		weapon_shots=weapon_shots+1
		createobject(lca.barrel.expl.id,weapon_x,weapon_y)
		endturn()
	end
end


lca.barrel.expl.id=addobject("lca.barrel.expl",lca.barrel.gfx_wpn)

function lca.barrel.expl.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].sy=0
	objects[id].timer=0
end

function lca.barrel.expl.draw(id,x,y)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	drawimage(lca.barrel.gfx_wpn,x,y)
end

function lca.barrel.expl.update(id,x,y)
	objects[id].sy=objects[id].sy+getgravity()
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		if collision(lca.barrel.gfx_wpn,x,y,1,1,1,-1,id)==1 then
			if (math.abs(objects[id].sy)>0.5) then playsound(lca.barrel.sfx_bounce) end
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		if y>getwatery()+5 then
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			removeobject(id)
			return
		end
	end
	objectposition(id,x,y)
	if objects[id].timer>0 then
		objects[id].timer=objects[id].timer+1
		if objects[id].timer>=20 then
			terrainexplosion(x,y,30,1)
			grey=math.random(0,40)
			if math.random(0,1)==1 then
				terrainalphaimage(gfx_crater75,getobjectx(id),getobjecty(id),math.random(6,9)*0.1,grey,grey,grey)
			else
				terrainalphaimage(gfx_crater100,getobjectx(id),getobjecty(id),math.random(6,9)*0.1,grey,grey,grey)
			end
			removeobject(id)
			arealdamage(x,y,100,70)
		end
	elseif firecollision(lca.barrel.gfx_wpn,x,y)>0 then
		objects[id].timer=1
	end
end

function lca.barrel.expl.damage(id,damage)
	if objects[id].timer==0 then 
		objects[id].timer=1
	end
end
