if lca==nil then lca={} end
lca.demon={}
lca.demon.pinky={}

lca.demon.gfx_wpn0=loadgfx("weapons/DooM/Demon_0.png")
setmidhandle(lca.demon.gfx_wpn0)
lca.demon.gfx_wpn1=loadgfx("weapons/DooM/Demon_1.png")
setmidhandle(lca.demon.gfx_wpn1)
lca.demon.sfx_attack=loadsfx("DSDMACT.wav")
lca.demon.sfx_laugh=loadsfx("DSSGTSIT.wav")

lca.demon.id=addweapon("lca.demon","Pinky Demon",lca.demon.gfx_wpn0,1,3)

function lca.demon.draw()
	if weapon_shots<=0 then
		hudinfo("Hit [Space] once to launch Pinky!")
		if getplayeraction(0)==0 then
			setblend(blend_alpha)
			setalpha(1)
			setcolor(255,255,255)
			setscale(getplayerdirection(0),1)
			setrotation(-(20+math.sin(os.clock()*15)*5)*getplayerdirection(0))
			drawimage(lca.demon.gfx_wpn0,getplayerx(0)+getplayerdirection(0)*7,getplayery(0)-5)
			hudcrosshair(6,3)
		end
	end
end

function lca.demon.attack(attack)
	if (weapon_shots<=0) then
		if (attack==1) then
			useweapon(0)
			playercontrol(0)
			secondsleft=math.floor(getframesleft()/50)
			changeturntime(15-secondsleft)
			weapon_shots=weapon_shots+1
			id=createprojectile(lca.demon.pinky.id)
			projectiles[id]={}
			projectiles[id].ignore=playercurrent()
			projectiles[id].x=getplayerx(0)+getplayerdirection(0)*8
			projectiles[id].y=getplayery(0)-3
			if collision(colplayer,projectiles[id].x,projectiles[id].y,1,1)==1 then
				if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
					projectiles[id].x=getplayerx(0)
				end
			end
			projectiles[id].sy=0
			projectiles[id].dir=getplayerdirection(0)
			projectiles[id].frame=0
			projectiles[id].timer=0
			weapon_timer=50
			playsound(lca.demon.sfx_laugh)
		end
	end
end

lca.demon.pinky.id=addprojectile("lca.demon.pinky")

function lca.demon.pinky.draw(id)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(projectiles[id].dir,1)
	if channelplaying(0)==0 then playsound(lca.demon.sfx_attack,0) end
	if projectiles[id].frame==0 then
		drawimage(lca.demon.gfx_wpn0,projectiles[id].x,projectiles[id].y-2)
	else
		drawimage(lca.demon.gfx_wpn1,projectiles[id].x,projectiles[id].y-2)
	end
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
	hudinfo("Hit [Space] again to detonate Demon!")
end

function lca.demon.pinky.update(id)
	weapon_timer=weapon_timer-1
	if collision(colplayer,projectiles[id].x,projectiles[id].y+4,1,1)==1 then
		projectiles[id].timer=projectiles[id].timer+1
		if projectiles[id].timer>8 then
			projectiles[id].timer=0
			projectiles[id].frame=1-projectiles[id].frame
		end
	else
		projectiles[id].timer=16
		projectiles[id].frame=1
	end
	if collision(col20x20,projectiles[id].x+projectiles[id].dir*11,projectiles[id].y-5,0,1)==1 then
				if playercollision()~=0 and playercollision()~=projectiles[id].ignore then
					playerpush(playercollision(),projectiles[id].dir*3,-10)
					playerdamage(playercollision(),10)
					playsound(sfx_splatter1)
					particle(p_ring,getplayerx(playercollision()),getplayery(playercollision()))
					particlecolor(255,0,0)
					blood(getplayerx(playercollision()),getplayery(playercollision()))
				end
			end
	projectiles[id].x=projectiles[id].x+projectiles[id].dir*0.5
	if collision(colplayer,projectiles[id].x,projectiles[id].y,1,1)==1 then
		if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
			doturn=1
			for i=1,6,1 do
				if (i%2)==1 then offset=(i+1)/2 else offset=-(i/2) end
				if collision(colplayer,projectiles[id].x,projectiles[id].y+offset,1,1)==0 then
					doturn=0; projectiles[id].ignore=0 projectiles[id].y=projectiles[id].y+offset; break
				elseif terraincollision()==0 and playercollision()==projectiles[id].ignore then
					doturn=0; projectiles[id].y=projectiles[id].y+offset; break
				end
			end
			if doturn==1 then
				projectiles[id].x=projectiles[id].x-projectiles[id].dir*0.5
				projectiles[id].dir=projectiles[id].dir*(-1)
			end
		end
	else
		projectiles[id].ignore=0
	end
	projectiles[id].sy=projectiles[id].sy+getgravity()
	msubt=math.ceil(math.abs(projectiles[id].sy)/3)
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(colplayer,projectiles[id].x,projectiles[id].y,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				projectiles[id].sy=0
				projectiles[id].y=projectiles[id].y-msuby
				break
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()-30 then
			stopchannel(0)
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater3)
			freeprojectile(id)
			endturn()
			return
		end
	end
	if getframesleft()<5 or (weapon_timer<=0 and keydown(key_attack)==1) then
		stopchannel(0)
		playsound(sfx_splatter2)
		arealdamage(projectiles[id].x,projectiles[id].y,100,50)
		terrainexplosion(projectiles[id].x,projectiles[id].y,50,1)
		grey=math.random(0,40)
		terrainalphaimage(gfx_crater200,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		freeprojectile(id)
		endturn()
	end
	scroll(projectiles[id].x,projectiles[id].y)
end