if lca==nil then lca={} end
lca.d2d_flamethrower={}
lca.d2d_flamethrower.bullet={}

lca.d2d_flamethrower.gfx_wpn=loadgfx("weapons/DooM/Flamethrower.png")
setmidhandle(lca.d2d_flamethrower.gfx_wpn)
lca.d2d_flamethrower.gfx_pro=loadgfx("weapons/DooM/flameball.png")
setmidhandle(lca.d2d_flamethrower.gfx_pro)
lca.d2d_flamethrower.sfx_attack=loadsfx("DSflamethrower.wav")

lca.d2d_flamethrower.id=addweapon("lca.d2d_flamethrower","Flamethrower",lca.d2d_flamethrower.gfx_wpn, 1,2)
lca.d2d_flamethrower.ammo=30	

function lca.d2d_flamethrower.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(lca.d2d_flamethrower.gfx_wpn,6,0)
	if lca.d2d_flamethrower.ammo-weapon_shots>0 then
		hudchargebar(lca.d2d_flamethrower.ammo-weapon_shots,lca.d2d_flamethrower.ammo)
	end
	if lca.d2d_flamethrower.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function lca.d2d_flamethrower.attack(attack)
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if attack==1 then
		useweapon(0)
		weapon_mode=1
	end
	if weapon_shots<lca.d2d_flamethrower.ammo and weapon_timer<=0 and weapon_mode==1 then
		weapon_timer=5
		playsound(lca.d2d_flamethrower.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(lca.d2d_flamethrower.bullet.id)
		projectiles[id]={}
                projectiles[id].ignore=playercurrent()
                projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*25.0
                projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
                projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
                projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
                projectiles[id].x=projectiles[id].x-projectiles[id].sx
                projectiles[id].y=projectiles[id].y-projectiles[id].sy
                lca.d2d_flamethrower.bullet.move(id,0)
                projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*(math.random(5,15))
                projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*(math.random(5,8))
                recoil(5)
                if weapon_shots>=lca.d2d_flamethrower.ammo then
                        endturn()
                end
        end
end

lca.d2d_flamethrower.bullet.id=addprojectile("lca.d2d_flamethrower.bullet")

function lca.d2d_flamethrower.bullet.draw(id)
	setblend(blend_light)
	setalpha(1)
	setcolor(255,255,0)
	setscale(1,1)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.d2d_flamethrower.gfx_pro,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.d2d_flamethrower.bullet.update(id)
        lca.d2d_flamethrower.bullet.move(id,1)
end

function lca.d2d_flamethrower.bullet.move(id,fx)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        if (fx==1) then
                particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
                particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
                particlefadealpha(0.01)
                particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
                particlefadealpha(0.04)
                particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
                particlefadealpha(0.04)
        end
        projectiles[id].sx=projectiles[id].sx+getwind()*1.4
        projectiles[id].sy=projectiles[id].sy+getgravity()*2
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/0.6)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
                                arealdamage(projectiles[id].x,projectiles[id].y,15,1)
                                if math.random(1,3)==1 then
                                createobject(o_fire,projectiles[id].x,projectiles[id].y)
                                end
                                grey=math.random(50,51)
                                        terrainalphaimage(gfx_crater25,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                freeprojectile(id)
                                break
                        end
                else
                        projectiles[id].ignore=0
                end
                if (projectiles[id].y)>getwatery()+5 then
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        playsound(sfx_hitwater1)
                        freeprojectile(id)
                        break
                end
        end
end