if lca==nil then lca={} end
lca.doompgun={}
lca.doompgun.ray={}

lca.doompgun.gfx_wpn=loadgfx("weapons/DooM/Plasmagun.png")
setmidhandle(lca.doompgun.gfx_wpn)
lca.doompgun.gfx_pro=loadgfx("weapons/DooM/PlsProj.png")
setmidhandle(lca.doompgun.gfx_pro)
lca.doompgun.sfx_attack=loadsfx("DSPLASMA.wav")
lca.doompgun.sfx_impact=loadsfx("DSFIRXPL.wav")

lca.doompgun.id=addweapon("lca.doompgun","Plasmagun",lca.doompgun.gfx_wpn,5,4)
lca.doompgun.ammo=20	

function lca.doompgun.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(lca.doompgun.gfx_wpn,6,0)
	if lca.doompgun.ammo-weapon_shots>0 then
		hudchargebar(lca.doompgun.ammo-weapon_shots,lca.doompgun.ammo)
	end
	if lca.doompgun.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function lca.doompgun.attack(attack)
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if weapon_shots<lca.doompgun.ammo and weapon_timer<=0 and attack==1 then
		useweapon(0)
		weapon_timer=7
		playsound(lca.doompgun.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(lca.doompgun.ray.id)
		projectiles[id]={}
		projectiles[id].ignore=playercurrent()
		projectiles[id].x=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(getplayerrotation(0)))*5.0
		projectiles[id].y=getplayery(0)+3+math.cos(math.rad(getplayerrotation(0)))*5.0
		projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*6.0
		projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*6.0
		projectiles[id].timer=0
		projectiles[id].x=projectiles[id].x-projectiles[id].sx*1.5
		projectiles[id].y=projectiles[id].y-projectiles[id].sy*1.5
		for i=1,3,1 do
			if lca.doompgun.ray.move(id)==1 then
				break
			end
		end
		recoil(2)
		particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*12,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*12)
		particlecolor(0,0,255)
		particlefadealpha(0.01)
		particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*12,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*12)
		particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
		particlefadealpha(0.005)
		if (weapon_shots>=lca.doompgun.ammo) then
			endturn()
		end
	end
end

lca.doompgun.ray.id=addprojectile("lca.doompgun.ray")

function lca.doompgun.ray.draw(id)
	setalpha(1)
	setblend(blend_light)
	setscale(0.7,0.7)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.doompgun.gfx_pro,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.doompgun.ray.update(id)
	lca.doompgun.ray.move(id)
end

function lca.doompgun.ray.move(id)
	projectiles[id].timer=projectiles[id].timer+1
	if projectiles[id].timer>300 then
		freeprojectile(id)
		return 1
	end
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby		
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,1,1)==1 or explode==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore or explode==1 then
				arealdamage(projectiles[id].x,projectiles[id].y,20,5)
				terrainexplosion(projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,5,2)
				if math.random(1,2)==1 then
					terrainalphaimage(gfx_crater25,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,math.random(6,9)*0.1,0,25,0)
				else
					terrainalphaimage(gfx_crater50,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5,math.random(6,9)*0.1,0,25,0)
				end
				playsound(lca.doompgun.sfx_impact)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)
				particlefadealpha(0.006)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)
				particlesize(1.5,1.5)
				particlecolor(0,0,255)
				particlefadealpha(0.01)
				for j=1,20,1 do
					particle(p_lightpuff,projectiles[id].x+math.sin(math.rad(rot))*5,projectiles[id].y-math.cos(math.rad(rot))*5)
					particlespeed(math.random(-20,20)*0.1,math.random(-20,20)*0.1)
					particlefadealpha(0.04)
					particlesize(math.random(40,70)*0.1,math.random(40,70)*0.1)
					particlecolor(0,0,255)
				end
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()+5 then
			playsound(lca.doompgun.sfx_impact)
			particle(p_smoke,projectiles[id].x,projectiles[id].y)
			freeprojectile(id)
			return 1
		end
	end
end