if lca==nil then lca={} end
lca.rocketla={}
lca.rocketla.rocket={}

lca.rocketla.gfx_wpn=loadgfx("weapons/DooM/rocketla.png")
setmidhandle(lca.rocketla.gfx_wpn)
lca.rocketla.gfx_icon=loadgfx("weapons/DooM/rocketla.png")
setmidhandle(lca.rocketla.gfx_icon)
lca.rocketla.gfx_pro=loadgfx("weapons/DooM/doomrocket.bmp")
setmidhandle(lca.rocketla.gfx_pro)
lca.rocketla.sfx_attack=loadsfx("DSRLAUNC.wav")

lca.rocketla.id=addweapon("lca.rocketla","Rocket Launcher",lca.rocketla.gfx_icon, 5,2)

function lca.rocketla.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(lca.rocketla.gfx_wpn,6,0)
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
end

function lca.rocketla.attack(attack)
if (weapon_shots<=0) and (attack==1) then
			useweapon(0)
			playsound(lca.rocketla.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(lca.rocketla.rocket.id)
			projectiles[id]={}
			projectiles[id].ignore=playercurrent()
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
     		projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*15.0
	    	projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*15.0
			recoil(2)
			endturn()
		end
	end

lca.rocketla.rocket.id=addprojectile("lca.rocketla.rocket")

function lca.rocketla.rocket.draw(id)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.rocketla.gfx_pro,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.rocketla.rocket.update(id)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
	particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
	particlefadealpha(0.01)
	particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
	particlefadealpha(0.04)
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1  or explode==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore or explode==1 then
				arealdamage(projectiles[id].x,projectiles[id].y,100,math.random(50,70))
				terrainexplosion(projectiles[id].x,projectiles[id].y,30,1)
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()+5 then
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			freeprojectile(id)
			break
		end
	end
	scroll(projectiles[id].x,projectiles[id].y)
end