if lca==nil then lca={} end
lca.sshotty={}
lca.sshotty.bullet={}

lca.sshotty.gfx_wpn=loadgfx("weapons/DooM/SSG.png")
setmidhandle(lca.sshotty.gfx_wpn)
lca.sshotty.gfx_pro=loadgfx("weapons/shot.bmp")
setmidhandle(lca.sshotty.gfx_pro)
lca.sshotty.sfx_attack=loadsfx("DSSSG.wav")

lca.sshotty.id=addweapon("lca.sshotty","supershotgun",lca.sshotty.gfx_wpn, 5,3)
lca.sshotty.ammo=2

function lca.sshotty.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(lca.sshotty.gfx_wpn,6,0)
	if lca.sshotty.ammo-weapon_shots>0 then
		hudammobar(lca.sshotty.ammo-weapon_shots,lca.sshotty.ammo)
	end
	if lca.sshotty.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function lca.sshotty.attack(attack)
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if weapon_shots<lca.sshotty.ammo and weapon_timer<=0 and attack==1 then
		useweapon(0)
		weapon_timer=20
		playsound(lca.sshotty.sfx_attack)
		weapon_shots=weapon_shots+1
		for i=1,9,1 do
			id=createprojectile(lca.sshotty.bullet.id)
			projectiles[id]={}
			rot=getplayerrotation(0)
			if i==2 then
				rot=rot-1
				elseif i==3 then
				rot=rot-2
				elseif i==4 then
				rot=rot-3
				elseif i==5 then
				rot=rot+2
				elseif i==6 then
				rot=rot+3
				elseif i==7 then
				rot=rot+4
				elseif i==8 then
				rot=rot+5
				elseif i==9 then
				rot=rot+0
			end 
			projectiles[id].ignore=playercurrent()
			projectiles[id].x=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(rot))*5.0
			projectiles[id].y=getplayery(0)+3+math.cos(math.rad(rot))*5.0
			projectiles[id].sx=math.sin(math.rad(rot))*15.0
			projectiles[id].sy=-math.cos(math.rad(rot))*15.0
			projectiles[id].x=projectiles[id].x-projectiles[id].sx*1.5
			projectiles[id].y=projectiles[id].y-projectiles[id].sy*1.5
			for i=1,3,1 do
				if lca.sshotty.bullet.move(id)==1 then
					break
				end
			end
		end
		recoil(7)
		particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
		particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
		particlefadealpha(0.005)
		if (weapon_shots>=lca.sshotty.ammo) then
			endturn()
		end
	end
end

lca.sshotty.bullet.id=addprojectile("lca.sshotty.bullet")

function lca.sshotty.bullet.draw(id)
	setblend(blend_light)
	setalpha(1)
	setcolor(255,125,0)
	setscale(1,1)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.sshotty.gfx_pro,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.sshotty.bullet.update(id)
	projectiles[id].sx=projectiles[id].sx+getwind()*0.02
	projectiles[id].sy=projectiles[id].sy+getgravity()*0.75
	lca.sshotty.bullet.move(id)
end

function lca.sshotty.bullet.move(id)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby		
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,1,1)==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore then
				if playercollision()~=0 then
					playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
					playerdamage(playercollision(),3)
					blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
				elseif objectcollision()>0 then
					objectdamage(objectcollision(),3)
				end
				terrainexplosion(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,12,0)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				particlefadealpha(0.004)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()+5 then
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			if math.random(1,2)==1 then
				playsound(sfx_hitwater2)
			else
				playsound(sfx_hitwater3)
			end
			freeprojectile(id)
			return 1
		end
	end
end